Skip to main content

Instance Actions

https://api.losant.com/instances/INSTANCE_ID

Below are the various requests that can be performed against the Instance resource, as well as the expected parameters and the potential responses.

Device Counts​

Returns device counts by day for the time range specified for this instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID/deviceCounts

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.deviceCounts.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
startNStart of range for device count query (ms since epoch)start=0
endNEnd of range for device count query (ms since epoch)end=1465790400000

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID/deviceCounts

Successful Responses​

CodeTypeDescription
200Device CountsDevice counts by day

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if instance was not found

Generate Report​

Generates a CSV report on instance stats

Method And Url​

POST https://api.losant.com/instances/INSTANCE_ID/generateReport

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.generateReport.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Request Body​

The body of the request should be serialized JSON that validates against the Instance Report Options Post schema. For example, the following would be a valid body for this request:

{
"email": "email@example.com",
"callbackUrl": "https://example.com/callback",
"resourceGroupBy": "organization",
"dateGroupBy": "month",
"includeSandbox": false,
"start": "2020-01-01T00:00:00.000Z",
"end": "2020-01-31T11:59:59.999Z"
}

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X POST \
https://api.losant.com/instances/INSTANCE_ID/generateReport

Successful Responses​

CodeTypeDescription
202Job Enqueued API ResultIf generation of report was successfully started

Error Responses​

CodeTypeDescription
400ErrorError if malformed request

Get​

Returns an instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.get.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID

Successful Responses​

CodeTypeDescription
200InstanceA single instance

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if instance was not found

Historical Summaries​

Return historical summary entries for an instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID/historicalSummaries

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.historicalSummaries.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
monthNTimestamp within the month to report a summary for.nowmonth=1609459204518
sortFieldNField to sort the results by. Accepted values are: resourceId, currentPeriodStartcurrentPeriodStartsortField=resourceId
sortDirectionNDirection to sort the results in. Accepted values are: asc, descascsortDirection=asc
pageNWhich page of results to return0page=0
perPageNHow many items to return per page100perPage=10
filterFieldNField to filter the results by. Blank or not provided means no filtering. Accepted values are: resourceType, resourceId, ownerId, ownerTypefilterField=resourceType
filterNFilter to apply against the filtered field. Blank or not provided means no filtering.filter=organization

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID/historicalSummaries

Successful Responses​

CodeTypeDescription
200Historical SummariesCollection of historical summaries

Error Responses​

CodeTypeDescription
400ErrorError if malformed request

Notebook Minute Counts​

Returns notebook execution usage by day for the time range specified for this instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID/notebookMinuteCounts

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.notebookMinuteCounts.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
startNStart of range for notebook execution query (ms since epoch)start=0
endNEnd of range for notebook execution query (ms since epoch)end=1465790400000

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID/notebookMinuteCounts

Successful Responses​

CodeTypeDescription
200Notebook Minute CountsNotebook usage information

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if instance was not found

Patch​

Updates information about an instance

Method And Url​

PATCH https://api.losant.com/instances/INSTANCE_ID

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.User, all.User.bounded, instance.*, or instance.patch.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Request Body​

The body of the request should be serialized JSON that validates against the Instance Patch schema. For example, the following would be a valid body for this request:

{
"reportConfigs": [
{
"emails": [
"email@example.com"
],
"callbackUrl": "https://example.com/callback",
"resourceGroupBy": "organization",
"dateGroupBy": "month",
"includeSandbox": false,
"periods": 3,
"cron": "0 4 1 * *"
},
{
"emails": [
"email@example.com",
"anotheremail@example.com"
],
"resourceGroupBy": "application",
"dateGroupBy": "month",
"includeSandbox": true,
"cron": "0 4 1 * *"
}
]
}

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X PATCH \
-d '{"reportConfigs":[{"emails":["email@example.com"],"callbackUrl":"https://example.com/callback","resourceGroupBy":"organization","dateGroupBy":"month","includeSandbox":false,"periods":3,"cron":"0 4 1 * *"},{"emails":["email@example.com","anotheremail@example.com"],"resourceGroupBy":"application","dateGroupBy":"month","includeSandbox":true,"cron":"0 4 1 * *"}]}' \
https://api.losant.com/instances/INSTANCE_ID

Successful Responses​

CodeTypeDescription
200InstanceThe updated instance object

Error Responses​

CodeTypeDescription
400ErrorError if malformed request

Payload Counts​

Returns payload counts for the time range specified for this instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID/payloadCounts

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.payloadCounts.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
startNStart of range for payload count query (ms since epoch)start=0
endNEnd of range for payload count query (ms since epoch)end=1465790400000
asBytesNIf the resulting stats should be returned as bytesfalseasBytes=true

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID/payloadCounts

Successful Responses​

CodeTypeDescription
200Payload StatsPayload counts, by type and source

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if instance was not found

Payload Counts Breakdown​

Returns payload counts per resolution in the time range specified for this instance

Method And Url​

GET https://api.losant.com/instances/INSTANCE_ID/payloadCountsBreakdown

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Instance, all.Instance.bounded, all.Instance.read, all.User, all.User.bounded, all.User.read, instance.*, or instance.payloadCountsBreakdown.

Request Path Components​

Path ComponentDescriptionExample
INSTANCE_IDID associated with the instance575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
startNStart of range for payload count query (ms since epoch)start=0
endNEnd of range for payload count query (ms since epoch)end=1465790400000
resolutionNResolution in milliseconds. Accepted values are: 86400000, 360000086400000resolution=86400000
asBytesNIf the resulting stats should be returned as bytesfalseasBytes=true
includeNonBillableNIf non-billable payloads should be included in the resultfalseincludeNonBillable=true

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/instances/INSTANCE_ID/payloadCountsBreakdown

Successful Responses​

CodeTypeDescription
200Payload Counts BreakdownSum of payload counts by date

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if instance was not found

Schemas​

Device Counts​

Schema for the result of a device counts request

Device Counts Schema​

  • ▶
    {} 3 keys
    • "http://json-schema.org/draft-07/schema#"
    • "object"
    • ▶
      {} 3 keys
      • ▶
        {} 2 keys
        • ▶
          {} 2 keys
          • ▶
            {} 2 keys

        Device Counts Example​

        • ▶
          {} 3 keys
          • "1999-05-20T05:00:00.000Z"
          • "1999-06-20T04:59:59.999Z"
          • ▶
            [] 1 item

          Error​

          Schema for errors returned by the API

          Error Schema​

          • ▶
            {} 3 keys
            • "http://json-schema.org/draft-07/schema#"
            • "object"
            • ▶
              {} 3 keys
              • ▶
                {} 1 key
                • ▶
                  {} 1 key
                  • ▶
                    {} 2 keys

                Error Example​

                • ▶
                  {} 2 keys
                  • "NotFound"
                  • "Application was not found"

                Historical Summaries​

                Schema for a collection of Historical Summaries

                Historical Summaries Schema​

                • ▶
                  {} 3 keys
                  • "http://json-schema.org/draft-07/schema#"
                  • "object"
                  • ▶
                    {} 9 keys
                    • ▶
                      {} 2 keys
                      • ▶
                        {} 1 key
                        • ▶
                          {} 1 key
                          • ▶
                            {} 1 key
                            • ▶
                              {} 1 key
                              • ▶
                                {} 1 key
                                • ▶
                                  {} 1 key
                                  • ▶
                                    {} 1 key
                                    • ▶
                                      {} 2 keys

                                  Historical Summaries Example​

                                  • ▶
                                    {} 7 keys
                                    • ▶
                                      [] 1 item
                                      • 8
                                      • 2
                                      • 100
                                      • 0
                                      • "name"
                                      • "asc"

                                    Instance​

                                    Schema for a single Instance

                                    Instance Schema​

                                    • ▶
                                      {} 3 keys
                                      • "http://json-schema.org/draft-07/schema#"
                                      • "object"
                                      • ▶
                                        {} 12 keys
                                        • ▶
                                          {} 3 keys
                                          • ▶
                                            {} 2 keys
                                            • ▶
                                              {} 2 keys
                                              • ▶
                                                {} 2 keys
                                                • ▶
                                                  {} 2 keys
                                                  • ▶
                                                    {} 1 key
                                                    • ▶
                                                      {} 3 keys
                                                      • ▶
                                                        {} 3 keys
                                                        • ▶
                                                          {} 3 keys
                                                          • ▶
                                                            {} 2 keys
                                                            • ▶
                                                              {} 2 keys
                                                              • ▶
                                                                {} 2 keys

                                                            Instance Example​

                                                            • ▶
                                                              {} 8 keys
                                                              • "B"
                                                              • ▶
                                                                {} 32 keys
                                                                • ▶
                                                                  [] 3 items
                                                                  • "2021-01-08T18:10:00.054Z"
                                                                  • "2021-01-08T18:10:00.054Z"
                                                                  • false
                                                                  • "5ff89ff825013dc6c2856188"
                                                                  • "5ff89ff825013dc6c2856188"

                                                                Instance Patch​

                                                                Schema for instance patch request

                                                                Instance Patch Schema​

                                                                • ▶
                                                                  {} 4 keys
                                                                  • "http://json-schema.org/draft-07/schema#"
                                                                  • "object"
                                                                  • ▶
                                                                    {} 3 keys
                                                                    • ▶
                                                                      {} 3 keys
                                                                      • ▶
                                                                        {} 3 keys
                                                                        • ▶
                                                                          {} 2 keys
                                                                        • false

                                                                      Instance Patch Example​

                                                                      • ▶
                                                                        {} 1 key
                                                                        • ▶
                                                                          [] 2 items

                                                                        Instance Report Options Post​

                                                                        Schema for the body of an instance report request

                                                                        Instance Report Options Post Schema​

                                                                        • ▶
                                                                          {} 4 keys
                                                                          • "http://json-schema.org/draft-07/schema#"
                                                                          • "object"
                                                                          • ▶
                                                                            {} 7 keys
                                                                            • ▶
                                                                              {} 3 keys
                                                                              • ▶
                                                                                {} 3 keys
                                                                                • ▶
                                                                                  {} 2 keys
                                                                                  • ▶
                                                                                    {} 2 keys
                                                                                    • ▶
                                                                                      {} 1 key
                                                                                      • ▶
                                                                                        {} 2 keys
                                                                                        • ▶
                                                                                          {} 2 keys
                                                                                        • false

                                                                                      Instance Report Options Post Example​

                                                                                      • ▶
                                                                                        {} 7 keys
                                                                                        • "email@example.com"
                                                                                        • "https://example.com/callback"
                                                                                        • "organization"
                                                                                        • "month"
                                                                                        • false
                                                                                        • "2020-01-01T00:00:00.000Z"
                                                                                        • "2020-01-31T11:59:59.999Z"

                                                                                      Job Enqueued API Result​

                                                                                      Schema for the result of a job being queued

                                                                                      Job Enqueued API Result Schema​

                                                                                      • ▶
                                                                                        {} 3 keys
                                                                                        • "http://json-schema.org/draft-07/schema#"
                                                                                        • "object"
                                                                                        • ▶
                                                                                          {} 3 keys
                                                                                          • ▶
                                                                                            {} 2 keys
                                                                                            • ▶
                                                                                              {} 2 keys
                                                                                              • ▶
                                                                                                {} 2 keys

                                                                                            Job Enqueued API Result Example​

                                                                                            • ▶
                                                                                              {} 3 keys
                                                                                              • true
                                                                                              • "clnHvJbyVkOWAZwYAwLP4"
                                                                                              • true

                                                                                            Notebook Minute Counts​

                                                                                            Schema for the result of a notebook minute counts request

                                                                                            Notebook Minute Counts Schema​

                                                                                            • ▶
                                                                                              {} 3 keys
                                                                                              • "http://json-schema.org/draft-07/schema#"
                                                                                              • "object"
                                                                                              • ▶
                                                                                                {} 3 keys
                                                                                                • ▶
                                                                                                  {} 2 keys
                                                                                                  • ▶
                                                                                                    {} 2 keys
                                                                                                    • ▶
                                                                                                      {} 2 keys

                                                                                                  Notebook Minute Counts Example​

                                                                                                  • ▶
                                                                                                    {} 3 keys
                                                                                                    • "1999-05-20T05:00:00.000Z"
                                                                                                    • "1999-06-20T04:59:59.999Z"
                                                                                                    • ▶
                                                                                                      [] 1 item

                                                                                                    Payload Counts Breakdown​

                                                                                                    Schema for the result of a payload counts breakdown request

                                                                                                    Payload Counts Breakdown Schema​

                                                                                                    • ▶
                                                                                                      {} 3 keys
                                                                                                      • "http://json-schema.org/draft-07/schema#"
                                                                                                      • "object"
                                                                                                      • ▶
                                                                                                        {} 3 keys
                                                                                                        • ▶
                                                                                                          {} 2 keys
                                                                                                          • ▶
                                                                                                            {} 2 keys
                                                                                                            • ▶
                                                                                                              {} 2 keys

                                                                                                          Payload Counts Breakdown Example​

                                                                                                          • ▶
                                                                                                            {} 3 keys
                                                                                                            • "1999-05-20T05:00:00.000Z"
                                                                                                            • "1999-06-20T04:59:59.999Z"
                                                                                                            • ▶
                                                                                                              [] 1 item

                                                                                                            Payload Stats​

                                                                                                            Schema for the result of a payload stats request

                                                                                                            Payload Stats Schema​

                                                                                                            • ▶
                                                                                                              {} 3 keys
                                                                                                              • "http://json-schema.org/draft-07/schema#"
                                                                                                              • "object"
                                                                                                              • ▶
                                                                                                                {} 19 keys
                                                                                                                • ▶
                                                                                                                  {} 2 keys
                                                                                                                  • ▶
                                                                                                                    {} 2 keys
                                                                                                                    • ▶
                                                                                                                      {} 2 keys
                                                                                                                      • ▶
                                                                                                                        {} 2 keys
                                                                                                                        • ▶
                                                                                                                          {} 2 keys
                                                                                                                          • ▶
                                                                                                                            {} 2 keys
                                                                                                                            • ▶
                                                                                                                              {} 2 keys
                                                                                                                              • ▶
                                                                                                                                {} 2 keys
                                                                                                                                • ▶
                                                                                                                                  {} 2 keys
                                                                                                                                  • ▶
                                                                                                                                    {} 2 keys
                                                                                                                                    • ▶
                                                                                                                                      {} 2 keys
                                                                                                                                      • ▶
                                                                                                                                        {} 2 keys
                                                                                                                                        • ▶
                                                                                                                                          {} 2 keys
                                                                                                                                          • ▶
                                                                                                                                            {} 2 keys
                                                                                                                                            • ▶
                                                                                                                                              {} 2 keys
                                                                                                                                              • ▶
                                                                                                                                                {} 2 keys
                                                                                                                                                • ▶
                                                                                                                                                  {} 2 keys
                                                                                                                                                  • ▶
                                                                                                                                                    {} 2 keys
                                                                                                                                                    • ▶
                                                                                                                                                      {} 2 keys

                                                                                                                                                  Payload Stats Example​

                                                                                                                                                  • ▶
                                                                                                                                                    {} 6 keys
                                                                                                                                                    • ▶
                                                                                                                                                      {} 1 key
                                                                                                                                                      • ▶
                                                                                                                                                        {} 2 keys
                                                                                                                                                        • ▶
                                                                                                                                                          {} 1 key
                                                                                                                                                          • ▶
                                                                                                                                                            {} 1 key
                                                                                                                                                            • ▶
                                                                                                                                                              {} 1 key
                                                                                                                                                              • ▶
                                                                                                                                                                {} 1 key

                                                                                                                                                              Was this page helpful?


                                                                                                                                                              Still looking for help? You can also search the Losant Forums or submit your question there.